export default {
  methods: {
    objMerge(target, source) {
      if (typeof target !== 'object') {
        target = {}
      }
      if (Array.isArray(source)) {
        return source.slice()
      }
      Object.keys(source).forEach(property => {
        const sourceProperty = source[property]
        if (Array.isArray(target[property])) {
          return target[property]
        } else if (typeof sourceProperty === 'object') {
          this.$set(target, property, this.objMerge(target[property], sourceProperty))
        } else if (target[property] === undefined) {
          this.$set(target, property, sourceProperty)
        }
      })
      return target
    }
  }
}
