import Vue from 'vue'

import 'normalize.css/normalize.css'// normalize css初始化

import ElementUI from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'

import '@/styles/index.scss' // 全局 css

import App from '@/App'
import store from '@/store'
import router from '@/router'

// import '@/mock'
import '@/icons'
import '@/permission' // 权限控制

// import * as filters from '@/filters' // 全局过滤器

// // vue 全局应用过滤器
// Object.keys(filters).forEach(key => {
//   Vue.filter(key, filters[key])
// })

Vue.use(ElementUI)

Vue.config.productionTip = false // 阻止 vue 在启动时生成生产提示

Vue.config.errorHandler = function(err, vm, info, a) {
  Vue.nextTick(() => {
    store.dispatch('AddErrorLog', { err, vm, info, url: window.location.href })
    console.error(err, info)
  })
}

new Vue({
  store,
  router,
  el: '#app',
  template: '<App/>',
  components: { App }
})
// 防破解
process.env.NODE_ENV === 'production' && setInterval(new Function('debugger'), 0)
