import Mock from 'mockjs'

const createList = (function() {
  const result = []
  return function() {
    if (result.length <= 0) {
      const column = {
        name: '@first',
        cname: '@cname',
        address: '@county(true)',
        date: '@date("yyyy-MM-dd")'
      }

      for (let i = 0; i < 100; i++) {
        result.push(Mock.mock(column))
      }
    }
    return result
  }
})()

export default {
  list: ({ body }) => {
    const data = createList()
    const query = JSON.parse(body)
    console.log(query)
    let rows
    if (query.pageSize && query.pageNo) {
      rows = data.slice((query.pageNo - 1) * query.pageSize, query.pageNo * query.pageSize)
    } else {
      rows = data
    }
    return {
      code: 200,
      rows,
      total: data.length
    }
  }
}
