import { cookie } from '@/utils/storage'
const app = {
  state: {
    sidebar: {
      opened: !+cookie.get_sidebarStatus(),
      withoutAnimation: false
    },
    device: 'desktop'
  },
  mutations: {
    TOGGLE_SIDEBAR: (state, withoutAnimation) => {
      if (state.sidebar.opened) {
        cookie.set_sidebarStatus(1)
      } else {
        cookie.set_sidebarStatus(0)
      }
      state.sidebar.opened = !state.sidebar.opened
      state.sidebar.withoutAnimation = withoutAnimation
    },
    CLOSE_SIDEBAR: (state, withoutAnimation) => {
      cookie.set_sidebarStatus(1)
      state.sidebar.opened = false
      state.sidebar.withoutAnimation = withoutAnimation
    },
    TOGGLE_DEVICE: (state, device) => {
      state.device = device
    }
  },
  actions: {
    ToggleSideBar: ({ commit }, config) => {
      commit('TOGGLE_SIDEBAR', config && config.withoutAnimation)
    },
    CloseSideBar({ commit }, { withoutAnimation }) {
      commit('CLOSE_SIDEBAR', withoutAnimation)
    },
    ToggleDevice({ commit }, device) {
      commit('TOGGLE_DEVICE', device)
    }
  }
}

export default app
