import { getMenu } from '@/api/menu.js'
import { setSession } from '@/utils/storage'
import { constantRouterMap, authRouterMap, otherRouterMap, routes, createdMenu } from '@/router'

const menuList = {
  state: {
    addRouters: [],
    menuRouters: routes
  },
  mutations: {
    SET_ROUTERS: (state, routers) => {
      state.addRouters = routers
      state.menuRouters = constantRouterMap.concat(routers, otherRouterMap)
    }
  },
  actions: {
    GenerateRoutes({ commit }, data) {
      return new Promise((resolve, reject) => {
        getMenu().then(rep => {
          const menu = rep.data.map(e => {
            return {
              title: e.title,
              url: e.url,
              icon: e.icon === 'larry-html' ? '' : e.icon,
              children: e.children.map(e1 => {
                return {
                  title: e1.title,
                  url: e1.url,
                  icon: e1.icon === 'larry-html' ? '' : e1.icon
                }
              })
            }
          })
          setSession('menu', menu)
          commit('SET_ROUTERS', createdMenu(menu).concat(authRouterMap))
          resolve(rep)
        }).catch(err => {
          reject(err)
        })
      })
    }
  }
}

export default menuList
