const aes = require('crypto-js/aes')
const md5 = require('crypto-js/md5')
const ecb = require('crypto-js/mode-ecb')
const utf8 = require('crypto-js/enc-utf8')
const pkcs7 = require('crypto-js/pad-pkcs7')
const base64 = require('crypto-js/enc-base64')
const CryptoJS = require('crypto-js')

export function toJson(obj) {
  return typeof obj === 'string' ? obj : JSON.stringify(obj)
}

/**
 * AES 加密
 * @param string 需加密的字符
 * @param cryptoKey 密钥
 */
export function AESencrypt(string, cryptoKey) {
  return aes.encrypt(utf8.parse(toJson(string)), utf8.parse(cryptoKey || process.env.CRYPTO_KEY), { mode: ecb, padding: pkcs7 }).toString()
}
export function __AESencrypt(string, cryptoKey) {
  const srcs = CryptoJS.enc.Utf8.parse(toJson(string))
  const key = CryptoJS.enc.Utf8.parse(cryptoKey || process.env.CRYPTO_KEY)
  const encrypted = CryptoJS.AES.encrypt(srcs, key, { mode: CryptoJS.mode.ECB, padding: CryptoJS.pad.Pkcs7 })
  return encrypted.ciphertext.toString().toUpperCase()
}

/**
 * AES 解密
 * @param string 需解密的字符
 * @param cryptoKey 密钥
 */
export function AESdecrypt(string, cryptoKey) {
  return utf8.stringify(aes.decrypt(string, utf8.parse(cryptoKey || process.env.CRYPTO_KEY), { mode: ecb, padding: pkcs7 })).toString()
}
export function __AESdecrypt(string, cryptoKey) {
  const encryptedHexStr = CryptoJS.enc.Hex.parse(string)
  const srcs = CryptoJS.enc.Base64.stringify(encryptedHexStr)
  const key = CryptoJS.enc.Utf8.parse(cryptoKey || process.env.CRYPTO_KEY)
  const decrypt = CryptoJS.AES.decrypt(srcs, key, { mode: CryptoJS.mode.ECB, padding: CryptoJS.pad.Pkcs7 })
  const decryptedStr = decrypt.toString(CryptoJS.enc.Utf8)
  return decryptedStr.toString()
}

/**
 * Base64 加密
 * @param string 需加密的字符
 */
export function Base64encrypt(string) {
  return base64.stringify(utf8.parse(toJson(string)))
}

/**
 * Base64 解密
 * @param string 需解密的字符
 */
export function Base64decrypt(string) {
  return base64.parse(string).toString(utf8)
}

/**
 * MD5 加密
 * @param string 需加密的字符
 */
export function MD5(string) {
  return md5(toJson(string)).toString().toString()
}
