import { debounce } from '@/utils'
export default {
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    id: {
      type: String,
      default() {
        return this.$options.name
      }
    },
    width: {
      type: String,
      default: '100%'
    },
    minWidth: {
      type: String
    },
    maxWidth: {
      type: String
    },
    height: {
      type: String,
      default: '100%'
    },
    minHeight: {
      type: String
    },
    maxHeight: {
      type: String
    },
    refreshTime: {
      type: Number,
      default: 150000
    }
  },
  computed: {
    sidebar() {
      return this.$store.state.app.sidebar.opened
    }
  },
  watch: {
    sidebar() {
      this.__resizeHanlder()
    }
  },
  data() {
    return {
      timer: null,
      refresh: true,
      auto: true
    }
  },
  created() {
    if (this.auto) {
      this.getDate && this.getDate()
      if (!this.timer && this.refreshTime && this.refresh) {
        this.timer = setInterval(() => {
          this.getDate && this.getDate()
        }, this.refreshTime)
      }
    }
  },
  mounted() {
    this.__resizeHanlder = debounce(() => { this.chart && this.chart.resize() }, 500)
    window.addEventListener('resize', this.__resizeHanlder)
  },
  beforeDestroy() {
    this.timer && clearInterval(this.timer)
    window.removeEventListener('resize', this.__resizeHanlder)
  }
}
